fogbugz_parse = {}

local function debug(X) end

function fogbugz_parse.cleanPageId(PageId)
   if PageId and type(PageId)=='string' and #PageId>=2 and PageId:sub(1,1)=='W' then
      return PageId:sub(2)
   end
   return PageId
end

function fogbugz_parse.sanitizeHtmlForXml(Html)
   local Html = Html
   Html = Html:gsub('&....;', ' ')
   Html = Html:gsub('&.....;', ' ')
   Html = Html:gsub('&hellip;', '7')
   return Html
end

function fogbugz_parse.findBreadCrumbsTable(PageHtml)
   return PageHtml:sub(PageHtml:find(
     '<table id=\"wiki%-page%-breadcrumbs%-container\">.*</tr></table>', 1, false))
end

function fogbugz_parse.findParent(PageHtml, PageIdPrefix) 

   local TableHtml = fogbugz_parse.findBreadCrumbsTable(PageHtml)
   TableHtml = fogbugz_parse.sanitizeHtmlForXml(TableHtml)

   local TableXmlRoot = xml.parse{data=TableHtml}
   local LinkCount = TableXmlRoot.table.tr:child("td",2):childCount('a')
   
   if LinkCount > 1 then
      local LinkNode = TableXmlRoot.table.tr:child("td", 2):child("a", LinkCount-1)
      local Parent = LinkNode.href:nodeValue():gsub('default%.asp%?W(%d*)', '%1')
      return (PageIdPrefix or '')..Parent
   end
end

function fogbugz_parse.findLinks(PageHtml, PageIdPrefix)
   local LinkList = {}
   local ContentStart = PageHtml:find('wiki%-page%-content')
   local Content = PageHtml:sub(ContentStart)
   for Link in Content:gfind('href="[^"]*\?W(%d+)"') do
      table.insert(LinkList, (PageIdPrefix or '')..Link)
   end
   return LinkList   
end

