require('dir_helper')

local function debug(A, B, C, D) end

fogcache_clean = {}

function fogcache_clean.cleanFilesForDeletedPages(Config, PagesThatShouldExist)
   
   debug(PagesThatShouldExist)

   local FileList = dir_helper.listdir(Config.DEST_PATH)
   
   local FilesThatShouldNotExist = {}
   
   local PageIdPattern = '^([0-9]+)(%.[0-9a-z.]+)$' 
   local ValidExtList = { ['.html']=1, ['.rev']=1, ['.nav.json']=1, ['.raw.html']=1 }
   debug(ValidExtList)
   
   local FileIndex, FileName
   for FileIndex, FileName in ipairs(FileList) do
      local PageId, PageMatchCount = FileName:gsub(PageIdPattern,'%1')
      if PageMatchCount>=1 and not PagesThatShouldExist[PageId] then
         local Ext, ExtMatchCount = FileName:gsub(PageIdPattern, '%2')
         if ExtMatchCount>=1 and ValidExtList[Ext] then
            debug(PageId, Ext)
            table.insert(FilesThatShouldNotExist, FileName)
         end
      end         
   end
   
   debug(FilesThatShouldNotExist)
   
   if #FilesThatShouldNotExist > 0 then
      local Ts = os.time()
      local DeletedDir = Config.DEST_PATH .. os.date('deleted.%Y-%m-%d_%H-%M-%S', Ts)
      debug(DeletedDir)
      os.execute('mkdir '..DeletedDir)
      for FileIndex, FileName in ipairs(FilesThatShouldNotExist) do
         os.execute('mv '..Config.DEST_PATH..FileName..' '..DeletedDir)
      end
   end
   
end