require('fogbugz_tree')

fogcache_tree = {}

local function debug(X) end

function fogcache_tree.constructTreeNode(ArticleMap, ArticleId, Suffix)
   local Article = ArticleMap[ArticleId]
   local TreeRoot = {id='W'..ArticleId, file=ArticleId..(Suffix or '')..'.html', title=Article.Title, children={}}
   local ChildIndex, ChildId
   for ChildIndex, ChildId in ipairs(Article.ChildList) do
      table.insert(TreeRoot.children, fogcache_tree.constructTreeNode(ArticleMap, ChildId, Suffix))
   end
   return TreeRoot
end

function fogcache_tree.constructTree(ArticleMap, StartPageId, Suffix)
   local RootIdList = fogbugz_tree.rootIdList(ArticleMap, StartPageId)
   debug(RootIdList)
   local TreeData = {}
   local RootIndex, RootId
   for RootIndex, RootId in ipairs(RootIdList) do
      table.insert(TreeData, fogcache_tree.constructTreeNode(ArticleMap, RootId, Suffix))
   end
   return TreeData
end
